#INCLUDE "dcdialog.CH"

#define CRLF  Chr(13)+Chr(10)


CLASS EmailVerify FROM CustomWebHandler

  EXPORTED:
    METHOD AddEmail, VerifyEmail, CleanUp

ENDCLASS

* -----------

METHOD EmailVerify:AddEmail()

LOCAL cHack, cEmail, cText, oRecord, cHtml

cHack := DC_XtoC(PValue(1))
cEmail := DC_XtoC(PValue(2))

wtf cHack, cEmail

cText := MemoRead('EmailVerify.Txt')
cText := Strtran(cText,'%hack%',cHack)
cText := Strtran(cText,'%email%',cEmail)
USE mnevn INDEX mnevn VIA 'FOXCDX'
IF !MNEVN->(dbSeek(cHack))
  SendMail( , cEmail, 'Transit Systems Email Address Verification',,, cText )
  oRecord := MNEVN->(DC_DbRecord():new())
  oRecord:hack := cHack
  oRecord:email := cEmail
  oRecord:status := 'PENDING'
  oRecord:date := Date()
  oRecord:time := Time()
  MNEVN->(DC_DbGather(oRecord,.t.))
  cHtml := 'Email sent to ' + cEmail
ELSE
  cHtml := 'Hack #' + cHack + ' has already been added.  Please wait 24 hours.'
ENDIF
MNEVN->(dbCloseArea())

RETURN cHtml

* -----------

METHOD EmailVerify:VerifyEmail()

LOCAL cHack, cEmail, cHtml, oRecord

cHack := DC_XtoC(PValue(1))
cEmail := DC_XtoC(PValue(2))
USE mnevn INDEX mnevn VIA 'FOXCDX'
IF MNEVN->(dbSeek(cHack))
  oRecord := MNEVN->(DC_DbRecord():new())
  MNEVN->(DC_DbScatter(oRecord))
  IF ElapTime(Date(),Time(),MNEVN->date,MNEVN->time) > (60 * 60 * 24)
    cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
    oRecord:status := 'DENIED'
    MNEVN->(DC_DbGather(oRecord))
    cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
  ELSE
    oRecord:status := 'VERIFIED'
    oRecord:date := Date()
    oRecord:time := Time()
    MNEVN->(DC_DbGather(oRecord))
    cHtml := 'Your Email Address has been verified.  Thank You!!!'
  ENDIF
ELSE
  cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
ENDIF
MNEVN->(dbCloseArea())

RETURN cHtml

* ------------

METHOD EmailVerify:CleanUp()

LOCAL nRecords, cHtml, cText

nRecords := 0
USE mnevn INDEX mnevn VIA 'FOXCDX' EXCLUSIVE
MNEVN->(dbSetOrder(0))
MNEVN->(dbGoTop())
DO WHILE !MNEVN->(Eof())
  IF MNEVN->status = 'DENIED' .OR. ;
     ElapTime(Date(),Time(),MNEVN->date,MNEVN->time) > ( 60 * 60 * 24 )
    MNEVN->(dbDelete())
    cText := 'Hack: ' + MNEVN->hack + ' ' + 'Email: ' + MNEVN->email
    SendMail( , 'office@transitsystems.com', 'Email Address not Verified',,, cText )
    nRecords++
  ENDIF
  MNEVN->(dbSkip())
ENDDO
MNEVN->(dbPack())
MNEVN->(dbCloseArea())
cHtml := 'MNEVN.DBF has been cleaned up. ' + Alltrim(Str(nRecords)) + ' deleted!'

RETURN cHtml

* -----------

FUNCTION ElapTime( dDate, cTime, dDateStart, cTimeStart )

LOCAL nSeconds, nSecondsStart

nSeconds := Val(Dtos(dDate)) * 60 * 60 * 24 + TimeToSec(cTime)

nSecondsStart := Val(Dtos(dDateStart)) * 60 * 60 * 24 + TimeToSec(cTimeStart)

RETURN nSeconds - nSecondsStart

* ----------

FUNCTION TimeToSec( cTime )

LOCAL nHours, nMinutes, nSeconds

DEFAULT cTime := Time()

nHours := Val(Substr(cTime,1,2))
nMinutes := Val(Substr(cTime,4,2))
nSeconds := Val(Substr(cTime,7,2))

RETURN (nHours * 60 * 24) + (nMinutes * 60) + nSeconds


