#INCLUDE "dcdialog.CH"

#Pragma Library("asinet10.lib")

* ----------

FUNCTION SendMail( cSender, cRecipient, cSubject, ;
                   cReplyTo, cAttachment, cText, cErrorText )

LOCAL oMail, oSender, oRecipient, oSmtp, lError := .t., cPrefix, ;
      cUserID, cPassword, cIniFile, nSMTPPort, aRef, aData, ;
      cSMTPServer

DEFAULT cSender := 'rogerdonnay@donnay-software.com', ;
        cRecipient := 'rogerdonnay@donnay-software.com'

aRef := { ;
  'SMTPServer', ;
  'SMTPPort', ;
  'UserID', ;
  'Password' }

aData := { ;
  Space(40), ;
  0, ;
  Space(40), ;
  Space(20) }

DC_IniLoad('Sendmail.Ini','EMAIL',aData,aRef)

cSMTPServer := Alltrim(aData[1])
nSMTPPort := aData[2]
cUserID := Alltrim(aData[3])
cPassword := Alltrim(aData[4])

IF Empty(cSMTPServer)
  cErrortext := 'No SMTP Server Address'
ELSEIF Empty(cSender)
  cErrorText := 'No Sender Address'
ELSEIF Empty(cRecipient)
  cErrorText := 'No Recipient Address'
ELSEIF Empty(cSubject)
  cErrortext := 'No Subject'
ELSE
  lError := .f.
ENDIF
IF lError
  RETURN .f.
ENDIF

oMail      := MIMEMessage():new()
oSender    := MailAddress():new( Alltrim(cSender) )
oRecipient := MailAddress():new( Alltrim(cRecipient) )

// Assemble the e-mail
oMail:setFrom( oSender     )
oMail:setSubject( Alltrim(cSubject) )

oMail:setMessage( cText )
oMail:addRecipient( oRecipient  )
IF !Empty(cReplyTo)
  oMail:addHeader( "Reply-To", Alltrim(cReplyTo) )
ENDIF
oMail:setContentType('text/html')

IF !Empty(cAttachment)
  oMail:attachFile( cAttachment  )
ENDIF

oSmtp := SMTPClient():new( Alltrim(cSMTPServer), nSMTPPort, 'donnay-software.com' )

IF oSmtp:connect(cUserId,cPassword)
  IF !oSmtp:send( oMail )
    cErrorText := 'Unable to send message - Cause unknown'
  ENDIF
  oSmtp:disconnect()
  lError := .f.
ELSE
  cErrorText := "Unable to connect to mail server"
ENDIF

IF !Empty(cErrorText)
  WTL cErrorText
ENDIF

RETURN !lError


