#INCLUDE "dcdialog.CH"

#define CRLF Chr(13)+Chr(10)


CLASS Test FROM CustomWebHandler

  EXPORTED:
    METHOD echo, getTime, echoVars, crash

ENDCLASS

* --------

METHOD Test:echoVars()

LOCAL cResponse, aVars, i, oForm

::setErrorBlock()
BEGIN SEQUENCE

oForm := ::httpRequest:getForm()
aVars := oForm:getCollection()
cResponse := '<H1> Echoing all Vars </H1>'
cResponse += '<pre>' + CRLF

FOR i := 1 TO Len(aVars)
  cResponse += aVars[i,1] + ' : ' + aVars[i,2] + CRLF
NEXT

cResponse += '</pre>'

RECOVER USING cResponse
END SEQUENCE

RETURN cResponse

* ------------

METHOD Test:echo( cParamName1 )

LOCAL cHtml := ""

::setErrorBlock()

cHtml += "<html><title>Donnay:echo() was called</title><body>"
cHtml += '<pre>'
cHtml += "Parameter cParamName1 is " + cParamName1 + CRLF
cHtml += 'Pcount is: ' + Alltrim(Str(Pcount())) + CRLF
cHtml += 'Query String is: ' + ::httpRequest:getQueryString() + CRLF
cHtml += "</pre></body></html>"

RETURN cHtml

//
// The method :get() handles the RESTful path CurrentTime/get
//
METHOD Test:getTime()

LOCAL cThreadId
LOCAL cResponse := ""

cThreadId := AllTrim(Str(ThreadId()))

::setErrorBlock()

BEGIN SEQUENCE

cResponse += "<!DOCTYPE html>"
cResponse += "<html>"
cResponse +=   "<head><title>"+ProcName()+"</title></head>"
cResponse +=   "<body>"
cResponse +=     "<h1>Current Time:</h1>"
cResponse +=     "<p>"+Time()+" (HH:MM:SS)</p>"
cResponse +=     "<small>By thread: "+cThreadId+"</small>"
cResponse +=   "</body>"
cResponse += "</html>"

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse

* -----------

METHOD Test:crash()

LOCAL cResponse

::setErrorBlock()

BEGIN SEQUENCE

&('CrashThisProgram()')

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse


